=== debian/changelog ===
libpmemobj-cpp (1.10-2) unstable; urgency=medium

  * Disable ppc64el.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 02 Jun 2020 19:42:15 +0200

libpmemobj-cpp (1.10-1) unstable; urgency=medium

  * New upstream release.
  * Enable ppc64el.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 28 May 2020 15:56:58 +0200

libpmemobj-cpp (1.10~rc1-1) experimental; urgency=medium

  * New upstream pre-release.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 27 May 2020 10:12:17 +0200
